//*****************************************************************************
// File: command.h
// Description: Nirva command classes
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

#ifndef _COMMAND_H
#define _COMMAND_H

#include "../nvs/task.h"
#include "error.h"
#include <string>


// Encoding
#define	ENCODING_NONE		0
#define	ENCODING_UTF8		1
#define	ENCODING_LATIN1		2

void EncodeCommandResult(int iEncoding, std::string& StringToEncode, void* pRequest);
void EncodeCommandInputString(int iEncoding, std::string& StringToEncode, void* pRequest);

/////////////////////////////////////////////////////////////////////////////
// NvServerCommand class
// The command class contains the context of a server command
class NvServerCommand
{
private:
public:
	std::string m_sService;
	std::string m_sClass;
	std::string m_sCommand;
	std::string m_sInContainer;
	std::string m_sOutContainer;
	std::string m_sLanguage;

	NvError m_Error;					// Error object
	NvObjIndStringList m_Parameters;	// Parameters
		
	NvServerCommand();
	virtual ~NvServerCommand();

	void Clear();
	void ParseParameters(const char *Parameters = NULL, NvObjIndStringList* Variables = NULL, char sep = 0);
	std::string GetVariable(std::string Value, NvObjIndStringList* Variables = NULL, const char *VarIdent = "#");
};




#endif //_COMMAND_H
