//*****************************************************************************
// File: nvcc.h
// Description: Nirva c/c++ client interface local declarations
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

// This file defines the nvs server classes.


#ifndef _NVCC_H
#define _NVCC_H

#ifdef WIN32
#define _CRT_SECURE_NO_WARNINGS
#define _CRT_NONSTDC_NO_DEPRECATE
#endif
#include "../nvs/task.h"
#include "../nvs/encrypt.h"
#include "../nvs/md5.h"
#include "../nvs/compress.h"
#include "../nvs/lzma/lzma.h"
#include "../nvs/util.h"
#include "../nvs/base64.h"
#include "../nvs/obj.h"
#include "http.h"
#include "../nvs/container.h"
#include "../nvs/garbage.h"
#include "command.h"
#include "request.h"
#include "nvc.h"
#include "java.h"
#include <string>


/////////////////////////////////////////////////////////////////////////////
// NvClient
// See nvc.cpp for the implementation of this class
//

class NvClient
{
public:
	bool Initialized;
	std::string MachineName;
	std::string MachineUser;
	NvRequestList Requests;					// Requests
	NvHttpConnectionList Connections;		// Current connections
	NvGarbage *Garbage;						// Garbage collector
	NvJavaRequestList JavaRequests;			// Java Requests
	NvJavaRequestList CfRequests;			// Cold Fusion java Requests
	
	NvClient();
	~NvClient();

	virtual bool InitInstance();
	virtual void ExitInstance();
};



// Used to get a pointer to the unique NvClient object
NvClient* GetMain();

#endif //_NVCC_H

