// ***************************************************************************************
// File: edotnet.h
// Description: interface to dotnet
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: This file contains the declaration of the exported functions of
//           the nvdotnet library.
// ***************************************************************************************

#ifndef _EDOTNET_H
#define _EDOTNET_H

#ifndef NVSTDCALL
#ifdef WIN32
#define NVSTDCALL __stdcall
#else
#define NVSTDCALL
#endif
#endif

#ifndef NVEXPORT
#ifdef WIN32
#define NVEXPORT __declspec(dllexport)
#else
#define NVEXPORT
#endif
#endif


#define DOMAIN_TYPE_APPLICATION		"APPLICATION"
#define DOMAIN_TYPE_SERVICE			"SERVICE"
#define DOMAIN_TYPE_WEBSERVICE		"WSERVICE"
#define DOMAIN_TYPE_SYSTEM			"SYSTEM"


// dotnet library entry points
typedef int (*DOTNETINIT)(const char* NirvaDir);
typedef void (*DOTNETFREE)();
typedef int (*DOTNETRUNCLASS)(const char* ClassName, void *pCommand);
typedef void (*DOTNETUNLOADDOMAIN)(const char* Type, const char* Name);


// Exported functions
extern "C"
{
int NVEXPORT NvInitDotnet(const char* NirvaDir);
void NVEXPORT NvFreeDotnet();
int NVEXPORT NvRunDotnetClass(const char* ClassName, void *pCommand);
void NVEXPORT NvDotnetUnloadDomain(const char* Type, const char* Name);
int NVEXPORT NvsCommand(void *pCommand);
int NVEXPORT NvsRender(void *RenderInterface, const char *ServiceName);
}


#endif //_EDOTNET_H
