// ***************************************************************************************
// File: base64.h
// Description: base64 declarations
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments:
// ***************************************************************************************

#ifndef _BASE64_H
#define _BASE64_H


// Base64 encoding functions
bool FileBase64(FILE* FileSource, FILE* FileDest, bool Encode, bool WithNewLines);
bool FileBase64(const char* SourceFile, const char* DestFile, bool Encode, bool WithNewLines);
bool FileBase64Encode(const char* SourceFile, const char* DestFile, bool WithNewLines = true);
bool FileBase64Decode(const char* SourceFile, const char* DestFile);
bool FileBase64Encode(FILE* FileSource, const char* DestFile, bool WithNewLines = true);
bool FileBase64Decode(FILE* FileSource, const char* DestFile);
bool FileBase64Encode(const char* SourceFile, FILE* FileDest, bool WithNewLines = true);
bool FileBase64Decode(const char* SourceFile, FILE* FileDest);
bool MemBase64(const char* SourceData, char** DestinationData, int* DataSize, bool Encode, bool WithNewLines);
bool MemBase64Encode(const char* SourceData, char** DestinationData, int* DataSize, bool WithNewLines = true);
bool MemBase64Decode(const char* SourceData, char** DestinationData, int* DataSize);
bool FileMemBase64(FILE* FileSource, char** DestinationData, int* DataSize, bool Encode, bool WithNewLines);
bool FileMemBase64(const char* SourceFile, char** DestinationData, int* DataSize, bool Encode, bool WithNewLines);
bool FileMemBase64Encode(FILE* FileSource, char** DestinationData, int* DataSize, bool WithNewLines = true);
bool FileMemBase64Decode(FILE* FileSource, char** DestinationData, int* DataSize);
bool FileMemBase64Encode(const char* SourceFile, char** DestinationData, int* DataSize, bool WithNewLines = true);
bool FileMemBase64Decode(const char* SourceFile, char** DestinationData, int* DataSize);
bool MemFileBase64(const char* SourceData, int DataSize, FILE* FileDest, bool Encode, bool WithNewLines);
bool MemFileBase64(const char* SourceData, int DataSize, const char* DestFile, bool Encode, bool WithNewLines);
bool MemFileBase64Encode(const char* SourceData, int DataSize, FILE* FileDest, bool WithNewLines = true);
bool MemFileBase64Decode(const char* SourceData, int DataSize, FILE* FileDest);
bool MemFileBase64Encode(const char* SourceData, int DataSize, const char* DestFile, bool WithNewLines = true);
bool MemFileBase64Decode(const char* SourceData, int DataSize, const char* DestFile);

#endif //_BASE64_H
